## xtrkcad 4.0.2

=== app/CMakeLists.txt ===
PROJECT(XTrackCAD)

# where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked
SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR})

IF(NOT WIN32)
	INCLUDE(FindPkgConfig)
	PKG_CHECK_MODULES(GTK "gtk+-2.0")
	PKG_CHECK_MODULES(GTKHTML "libgtkhtml-2.0")
ENDIF(NOT WIN32)

ADD_SUBDIRECTORY(tools)
ADD_SUBDIRECTORY(lib)
ADD_SUBDIRECTORY(wlib)
ADD_SUBDIRECTORY(help)
ADD_SUBDIRECTORY(bin)

=== app/Makefile ===

all: update

update: debug product

debug:
	(cd wlib/gtklib; make debug2;)
	(cd tools; cmake .; make;)
	(cd help; make;)
	(cd doc; cmake .; make; )
	(cd lib/params; make;)
	(cd lib; make;)
	(cd bin; make debug;)

product:
	(cd wlib/gtklib; make product2;)
	(cd tools; cmake .; make;)
	(cd help; make;)
	(cd doc; cmake .; make;)
	(cd lib/params; make;)
	(cd lib; make;)
	(cd bin; make product;)

ins:
	(./install.sh )

clean:
	(cd wlib/gtklib; make clean;)
	(cd help; make clean;)
	(cd lib/params; make clean ;)
	(cd lib; make clean;)
	(cd bin; make clean;)
	rm -f cscope.out *.tar.gz
	rm -fr install
	find . -name \*~ -exec rm {} \; 
	rm -fr bin/Debug
	rm -fr bin/Release
	rm -fr wlib/mswlib/Debug
	rm -fr wlib/mswlib/Release
	rm -fr mswrel
	find . -name cscope.out -exec rm {} \; 
	rm -fr srcdox doxygen.log

# the following (re)generates source code documentation.
# There are a host of dependencis to be properly determined and specified.
# For now just do it on demand.

.PHONY:  srcdox
srcdox:
	doxygen xtrkcad-fork-Doxyfile

=== app/bin/CMakeLists.txt ===
ADD_EXECUTABLE(cnvdsgn cnvdsgn.c utility.c)
TARGET_LINK_LIBRARIES(cnvdsgn m)
GET_TARGET_PROPERTY(cnvdsgn_EXE cnvdsgn LOCATION)

MACRO(GENERATE_LIN lin_name)
	ADD_CUSTOM_COMMAND(
		OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${lin_name}.lin
		DEPENDS cnvdsgn ${CMAKE_CURRENT_SOURCE_DIR}/${lin_name}.src
		COMMAND ${cnvdsgn_EXE} < ${CMAKE_CURRENT_SOURCE_DIR}/${lin_name}.src > ${CMAKE_CURRENT_BINARY_DIR}/${lin_name}.lin
		)
ENDMACRO(GENERATE_LIN)

GENERATE_LIN(to3way)
GENERATE_LIN(tocrv)
GENERATE_LIN(tocrvsct)
GENERATE_LIN(todcross)
GENERATE_LIN(todslip)
GENERATE_LIN(tolcross)
GENERATE_LIN(torcross)
GENERATE_LIN(toreg)
GENERATE_LIN(tosslip)
GENERATE_LIN(tostrsct)
GENERATE_LIN(towye)
GENERATE_LIN(toxing)

SET(LIN_SOURCES
	${CMAKE_CURRENT_BINARY_DIR}/to3way.lin
	${CMAKE_CURRENT_BINARY_DIR}/tocrv.lin
	${CMAKE_CURRENT_BINARY_DIR}/tocrvsct.lin
	${CMAKE_CURRENT_BINARY_DIR}/todcross.lin
	${CMAKE_CURRENT_BINARY_DIR}/todslip.lin
	${CMAKE_CURRENT_BINARY_DIR}/tolcross.lin
	${CMAKE_CURRENT_BINARY_DIR}/torcross.lin
	${CMAKE_CURRENT_BINARY_DIR}/toreg.lin
	${CMAKE_CURRENT_BINARY_DIR}/tosslip.lin
	${CMAKE_CURRENT_BINARY_DIR}/tostrsct.lin
	${CMAKE_CURRENT_BINARY_DIR}/towye.lin
	${CMAKE_CURRENT_BINARY_DIR}/toxing.lin
	)

SET(SOURCES
	${LIN_SOURCES}
	ccurve.c
	cdraw.c
	celev.c
	cgroup.c
	chndldto.c
	chotbar.c
	cjoin.c
	cmisc.c
	cmisc2.c
	cmodify.c
	cnote.c
	compound.c
	cparalle.c
	cprint.c
	cprofile.c
	cpull.c
	cruler.c
	cselect.c
	csnap.c
	csplit.c
	cstraigh.c
	cstruct.c
	ctext.c
	ctodesgn.c
	ctrain.c
	cturnout.c
	cturntbl.c
	cundo.c
	custom.c
	dbench.c
	dbitmap.c
	dcar.c
	dcmpnd.c
	dcustmgm.c
	dease.c
	denum.c
	dlayer.c
	doption.c
	dpricels.c
	dprmfile.c
	draw.c
	drawgeom.c
	elev.c
	fileio.c
	lprintf.c
	macro.c
	misc.c
	misc2.c
	param.c
	shrtpath.c
	tcurve.c
	tease.c
	track.c
	trkseg.c
	tstraigh.c
	utility.c
	)

INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR})
INCLUDE_DIRECTORIES(${help_BINARY_DIR})
INCLUDE_DIRECTORIES(${wlib_SOURCE_DIR}/include)

ADD_LIBRARY(xtrackcad-lib SHARED ${SOURCES})
TARGET_LINK_LIBRARIES(xtrackcad-lib xtrackcad-help)

ADD_EXECUTABLE(xtrackcad xtrackcad.c)
TARGET_LINK_LIBRARIES(xtrackcad xtrackcad-lib)
TARGET_LINK_LIBRARIES(xtrackcad xtrackcad-wlib)
TARGET_LINK_LIBRARIES(xtrackcad ${GTK_LIBRARIES})

ADD_EXECUTABLE(mkturnout
	${LIN_SOURCES}
	ctodesgn.c
	utility.c
	)
TARGET_LINK_LIBRARIES(mkturnout m)
SET_TARGET_PROPERTIES(mkturnout PROPERTIES COMPILE_FLAGS -DMKTURNOUT)

INSTALL(TARGETS xtrackcad mkturnout xtrackcad-lib
	RUNTIME DESTINATION bin
	LIBRARY DESTINATION lib
	)

=== app/bin/Makefile ===

# $Header: /cvsroot/xtrkcad-fork/xtrkcad/app/bin/Makefile,v 1.8 2007/12/13 19:40:51 m_fischer Exp $
#

CC = gcc

WLIB = ../wlib
VER = d
COPTS = -Wall
CINCLS = -I$(WLIB)/include
PACKAGEDIR = ./package
VER=0.1
XXXDIR = /usr3/downloads/src/gtk/gtk+-1.2.10
#GLIBDIR = /usr/src/glib-1.2.1

all: debug

CONVERTERS = bdf2xtp

MISCOBJS = \
	ccurve.o \
	cdraw.o \
	celev.o \
	cgroup.o \
	chndldto.o \
	chotbar.o \
	cjoin.o \
	cmisc.o \
	cmisc2.o \
	cnote.o \
	compound.o \
	cparalle.o \
	cprint.o \
	cprofile.o \
	cpull.o \
	cruler.o \
	cselect.o \
	csplit.o \
	csnap.o \
	cstraigh.o \
	cstruct.o \
	ctext.o \
	ctodesgn.o \
	ctrain.o \
	cturnout.o \
	cturntbl.o \
	cundo.o \
	custom.o \
	dbench.o \
	dbitmap.o \
	dcar.o \
	dcmpnd.o \
	dcustmgm.o \
	dease.o \
	denum.o \
	dlayer.o \
	doption.o \
	dpricels.o \
	dprmfile.o \
	draw.o \
	drawgeom.o \
	elev.o \
	fileio.o \
	lprintf.o \
	macro.o \
	misc.o \
	misc2.o \
	param.o \
	smalldlg.o \
	shrtpath.o \
	tcurve.o \
	tease.o \
	track.o \
	trkseg.o \
	tstraigh.o \
	utility.o

OBJS = $(MISCOBJS)

LIB = xtrkcad$(VER).a
.PRECIOUS: $(LIB)

WLIBS = $(WLIB)/gtklib/gtk2lib$(VER).a

#GTKLIBS = -lgtk-x11-2.0 -lgdk-x11-2.0 -lglib-2.0 -lpango-1.0
GTKLIBS = `pkg-config --libs libgtkhtml-2.0`
XLIBS = -L/usr/X11R6/lib -lX11

LIBS = $(WLIBS) $(GTKLIBS) $(XLIBS) -lm


CSRCS = $(OBJS:.o=.c) custom.c
HDRS = \
	compound.h \
	ccurve.h \
	cjoin.h \
	cmodify.c \
	cselect.h \
	cstraigh.h \
	ctrain.h \
	cundo.h \
	custom.h \
	common.h \
	misc.h \
	draw.h \
	drawgeom.h \
	track.h \
	trackx.h \
	utility.h \
	version.h \
	acclkeys.h \
	misc2.h \
	param.h \
	fileio.h \
	shrtpath.h

XPMS = \
	above.xpm below.xpm \
	bo_edge.xpm bo_flat.xpm \
	bo_ll.xpm bo_lld.xpm bo_lli.xpm bo_llu.xpm \
	bo_lr.xpm bo_lrd.xpm bo_lri.xpm bo_lru.xpm \
	bo_t.xpm bo_ti.xpm bo_tl.xpm bo_tr.xpm \
	carpart.xpm carproto.xpm \
	circle1.xpm circle2.xpm circle3.xpm \
	cnote.xpm \
	curve1.xpm curve2.xpm curve3.xpm curve4.xpm \
	dbench.xpm dbox.xpm \
	dcircle1.xpm dcircle2.xpm dcircle3.xpm \
	dcurve1.xpm dcurve2.xpm dcurve3.xpm dcurve4.xpm \
	ddimlin.xpm \
	delete.xpm \
	describe.xpm \
	dfilbox.xpm dfilpoly.xpm \
	dflcrcl1.xpm dflcrcl2.xpm dflcrcl3.xpm \
	dline.xpm dpoly.xpm dtbledge.xpm \
	elev.xpm \
	ebroad.xpm egtbroad.xpm egtsharp.xpm eltbroad.xpm enone.xpm enormal.xpm esharp.xpm \
	exit.xpm \
	export.xpm \
	extend.xpm \
	flip.xpm \
	go.xpm \
	helix.xpm \
	hndldto.xpm \
	import.xpm \
	join.xpm \
	move.xpm \
	movedesc.xpm \
	openbutt.xpm \
	newcar.xpm \
	parallel.xpm \
	partlist.xpm \
	profile.xpm \
	pull.xpm \
	redo.xpm \
	rotate.xpm \
	ruler.xpm \
	select.xpm \
	snapcurs.xpm snapvis.xpm \
	splittrk.xpm \
	stop.xpm \
	straight.xpm \
	struct.xpm \
	text.xpm \
	train.xpm \
	turnout.xpm turntbl.xpm \
	tunnel.xpm \
	undo.xpm \
	zero.xpm \
	zoom.xpm zoomin.xpm zoomout.xpm \
	xtc64.xpm


BMPS = xtrkcad.bmp \
	bigdot.bmp \
	bma0.bmp bma135.bmp bma45.bmp bma90.bmp bmendpt.bmp \
	note.bmp arrow0.bmp arrow3.bmp arrows.bmp flash.bmp \
	triangl.bmp triangr.bmp triangu.bmp triangd.bmp cross0.bmp \
	bitmaps/l1.xbm bitmaps/l2.xbm bitmaps/l3.xbm bitmaps/l4.xbm \
	bitmaps/l5.xbm bitmaps/l6.xbm bitmaps/l7.xbm bitmaps/l8.xbm \
	bitmaps/l9.xbm bitmaps/l10.xbm bitmaps/l11.xbm bitmaps/l12.xbm \
	bitmaps/l13.xbm bitmaps/l14.xbm bitmaps/l15.xbm bitmaps/l16.xbm \
	bitmaps/l17.xbm bitmaps/l18.xbm bitmaps/l19.xbm bitmaps/l20.xbm \
	square10.bmp \
	hotbarl.bmp hotbarr.bmp \
	mtbox.bmp chkbox.bmp \
	snapcurs.bmp snapvis.bmp bridge.bmp xtc16.bmp xtc64.bmp

MISC = cnvdsgn.c bdf2xtp.c 
TURNOUTSRCS = to3way.src todcross.src torcross.src tostrsct.src \
	tocrv.src todslip.src toreg.src towye.src \
	tocrvsct.src tolcross.src tosslip.src toxing.src
TURNOUTLINS = to3way.lin todcross.lin torcross.lin tostrsct.lin \
	tocrv.lin todslip.lin toreg.lin towye.lin \
	tocrvsct.lin tolcross.lin tosslip.lin toxing.lin
EXAMPLES = examples/mr03.trk

MSWSRCS = xtrkcad.def xtrkcad.rc xtrkcad.mak xtrkcad.dsp xtrkcad.dsw
PRODS=$(TURNOUTLINS) $(SHROUDFILES) bllnhlp.c
SRCS = $(MISC) $(CSRCS) $(HDRS) $(BMPS) $(XPMS) $(TURNOUTSRCS) $(MSWSRCS) Makefile $(LIB) $(LIB)

#$(VER)xvlib:
#	cd xvlib; $(MAKE) CC="$(CC)" COPTS="$(COPTS)" VER="$(VER)"

.c.a:
	@echo $<
	$(CC) -c $(CFLAGS) $(COPTS) $(CINCLS) $<
	@ar rv $@ $*.o
	@rm -f $*.o

.src.lin:
	@echo $<
	./cnvdsgn < $*.src > $*.lin

LIBOBJS = \
	$(LIB)(bllnhlp.o) \
	$(LIB)(ccurve.o) \
	$(LIB)(cdraw.o) \
	$(LIB)(celev.o) \
	$(LIB)(cgroup.o) \
	$(LIB)(chndldto.o) \
	$(LIB)(chotbar.o) \
	$(LIB)(cjoin.o) \
	$(LIB)(cmisc.o) \
	$(LIB)(cmisc2.o) \
	$(LIB)(cmodify.o) \
	$(LIB)(cnote.o) \
	$(LIB)(compound.o) \
	$(LIB)(cparalle.o) \
	$(LIB)(cprint.o) \
	$(LIB)(cprofile.o) \
	$(LIB)(cpull.o) \
	$(LIB)(cruler.o) \
	$(LIB)(cselect.o) \
	$(LIB)(csnap.o) \
	$(LIB)(csplit.o) \
	$(LIB)(cstraigh.o) \
	$(LIB)(cstruct.o) \
	$(LIB)(ctext.o) \
	$(LIB)(ctodesgn.o) \
	$(LIB)(ctrain.o) \
	$(LIB)(cturnout.o) \
	$(LIB)(cturntbl.o) \
	$(LIB)(cundo.o) \
	$(LIB)(custom.o) \
	$(LIB)(dbench.o) \
	$(LIB)(dbitmap.o) \
	$(LIB)(dcar.o) \
	$(LIB)(dcmpnd.o) \
	$(LIB)(dcustmgm.o) \
	$(LIB)(dease.o) \
	$(LIB)(denum.o) \
	$(LIB)(dlayer.o) \
	$(LIB)(dprmfile.o) \
	$(LIB)(doption.o) \
	$(LIB)(dpricels.o) \
	$(LIB)(draw.o) \
	$(LIB)(drawgeom.o) \
	$(LIB)(elev.o) \
	$(LIB)(fileio.o) \
	$(LIB)(lprintf.o) \
	$(LIB)(macro.o) \
	$(LIB)(misc.o) \
	$(LIB)(misc2.o) \
	$(LIB)(param.o) \
	$(LIB)(smalldlg.o) \
	$(LIB)(shrtpath.o) \
	$(LIB)(tcurve.o) \
	$(LIB)(tease.o) \
	$(LIB)(track.o) \
	$(LIB)(trkseg.o) \
	$(LIB)(tstraigh.o) \
	$(LIB)(utility.o)


$(LIB) : $(LIBOBJS)
	ranlib $(LIB)

update: debug product #libc5-debug libc5-product

debug:
	$(MAKE) CC="$(CC)" COPTS="$(COPTS)" CINCLS="$(CINCLS)" CFLAGS="-g -DDEBUG" LDFLAGS= VER=d GTKVER="2" GTKLIBS="$(GTKLIBS)" xtrkcadd mkturnout #$(CONVERTERS)

staticgtklib:
	$(MAKE) CC="$(CC)" COPTS="$(COPTS)" CINCLS="$(CINCLS)" CFLAGS="-g -DDEBUG" LDFLAGS= VER=d GTKLIBS="$(GTKSTATICLIBS)" xtrkcadd-static mkturnout #$(CONVERTERS)

product:
	$(MAKE) CC="$(CC)" COPTS="$(COPTS)" CINCLS="$(CINCLS)" CFLAGS="-O2 -DFASTRACK" LDFLAGS= VER="" GTKVER="2" GTKLIBS="$(GTKLIBS)" xtrkcad #$(CONVERTERS)

profile:
	$(MAKE) CC="$(CC)" COPTS="$(COPTS)" CINCLS="$(CINCLS)" CFLAGS="-pg -O2 -DFASTRACK" LDFLAGS="-pg" VER=p xtrkcadp #$(CONVERTERS)


checked:
	$(MAKE) CC="checkergcc" COPTS="$(COPTS)" CINCLS="$(CINCLS)" CFLAGS="-g -DDEBUG" LDFLAGS= VER=c xtrkcadc $(CONVERTERS)

mkpackage:
	-rm -fr $(PACKAGEDIR)
	mkdir $(PACKAGEDIR)
	mkdir $(PACKAGEDIR)/xtrkcad
	mkdir $(PACKAGEDIR)/xtrkcad/examples
	cp xtrkcad $(HELPFILES) $(PARAMS) $(PACKAGEDIR)/xtrkcad/
	strip $(PACKAGEDIR)/xtrkcad/xtrkcad
	cp examples/* $(PACKAGEDIR)/xtrkcad/examples/
	cp AAAREADME $(PACKAGEDIR)/xtrkcad/
	cd $(PACKAGEDIR)/; tar cvfz ../xtrkcad-$(VER).tar.gz ./xtrkcad/
	(cat AAAREADME ; uuencode xtrkcad-$(VER).tar.gz < xtrkcad-$(VER).tar.gz ) > xtrkcad-$(VER).tar.gz.u
	csplit -k -f xtrkcad-0.1.tar.gz.u. xtrkcad-0.1.tar.gz.u 1000 \{999\}

xtrkcad$(VER): $(LIB) xtrkcad$(VER).o $(WLIBS)
	ar xv $(LIB) misc.o
	$(CC) $(LDFLAGS) -o xtrkcad$(VER) misc.o xtrkcad$(VER).o $(LIB) $(LIBS)
	rm -f misc.o
	if [ "$(VER)"x = x ] ; then cp xtrkcad xtrkcad-ns; strip xtrkcad; fi

xtrkcad$(VER)-static: $(LIB) xtrkcad$(VER).o
	ar xv $(LIB) misc.o
	$(CC) $(LDFLAGS) -o xtrkcad$(VER)-static misc.o xtrkcad$(VER).o $(LIB) $(LIBS) -lXext
	rm -f misc.o

xtrkcad$(VER).o: custom.c version.h
	$(CC) -c $(CFLAGS) $(COPTS) $(CINCLS) -o xtrkcad$(VER).o custom.c

wintest: wintest.o xvdraw.o
	$(CC) -o wintest wintest.o xvdraw.o $(LIBS)

xvfilsel: xvfilsel.c
	$(CC) $(CFLAGS) $(CINCLS) -g -DTEST xvfilsel.c
	$(CC) -o xvfilsel xvfilsel.o xtrkcadd.a $(LIBS)

xvfont: xvfont.c
	$(CC) -c $(CFLAGS) $(CINCLS) -g -DTEST xvfont.c
	ar xv xtrkcadd.a xvcmd.o xvdraw.o utility.o
	$(CC) -o xvfont xvfont.o xvcmd.o xvdraw.o utility.o $(LIBS)
	rm -f xvcmd.o xvdraw.o utility.o

#.c.o:
#	$(CC) $(CFLAGS) -c $<

tar:
#	cd mswlib; make tar
#	cd xvlib; make tar
	tar cvf track.tar $(SRCS) $(PRODS) #mswlib/mswlib.tar xvlib/xvlib.tar

tag:
	if [ "$(TAG)"x = "x" ] ; then echo define TAG ; else rcs -N$(TAG):HEAD $(SRCS) ; fi

fetch:
	if [ "$(TAG)"x != "x" ] ; then TAG=-r$(TAG) ; fi ;\
	co $$TAG  $(SRCS)

src:
	@echo $(SRCS) $(PRODS)

bmps:
	@echo $(BMPS)

xpms:
	@echo $(XPMS)

rcssrc:
	@echo $(SRCS)

depend:

$(LIB)(ctodesgn.o): $(TURNOUTLINS)

$(LIB)(fileio.o):

cnvdsgn: cnvdsgn.c
	cc -o cnvdsgn cnvdsgn.c utility.c -lm

toreg.lin: cnvdsgn toreg.src
	./cnvdsgn < toreg.src > toreg.lin
tocrv.lin: cnvdsgn tocrv.src
	./cnvdsgn < tocrv.src > tocrv.lin
towye.lin: cnvdsgn towye.src
	./cnvdsgn < towye.src > towye.lin
to3way.lin: cnvdsgn to3way.src
	./cnvdsgn < to3way.src > to3way.lin
toxing.lin: cnvdsgn toxing.src
	./cnvdsgn < toxing.src > toxing.lin
tosslip.lin: cnvdsgn tosslip.src
	./cnvdsgn < tosslip.src > tosslip.lin
todslip.lin: cnvdsgn todslip.src
	./cnvdsgn < todslip.src > todslip.lin
torcross.lin: cnvdsgn torcross.src
	./cnvdsgn < torcross.src > torcross.lin
tolcross.lin: cnvdsgn tolcross.src
	./cnvdsgn < tolcross.src > tolcross.lin
todcross.lin: cnvdsgn todcross.src
	./cnvdsgn < todcross.src > todcross.lin
tostrsct.lin: cnvdsgn tostrsct.src
	./cnvdsgn < tostrsct.src > tostrsct.lin
tocrvsct.lin: cnvdsgn tocrvsct.src
	./cnvdsgn < tocrvsct.src > tocrvsct.lin

mkturnout: ctodesgn.c utility.c
	cc -g -o mkturnout $(CINCLS) -DMKTURNOUT ctodesgn.c utility.c -lm

misc.o: misc.c messages.inc messages.h

clean:
	rm -f $(OBJS) $(TURNOUTLINS) $(LIB) xtrkcad xtrkcad-ns xtrkcadd mkturnout cnvdsgn $(MISCOBJS)
	rm -f xtrkcad.a xtrkcadd.a
	rm -f xtrkcad.o xtrkcadd.o messages.h bllnhlp.c 
	rm -f *.exe

#$(OBJS):	$(HDRS)

#$(LIBOBJS):	$(HDRS)


$(LIB)(bllnhlp.o): bllnhlp.c $(WLIB)/include/wlib.h
$(LIB)(ccurve.o): ccurve.c track.h ccurve.h cstraigh.h cjoin.h helix.xpm curve1.xpm curve2.xpm \
	curve3.xpm curve4.xpm circle1.xpm circle2.xpm circle3.xpm
$(LIB)(cdraw.o): cdraw.c track.h ccurve.h drawgeom.h dline.xpm ddimlin.xpm dbench.xpm \
	dtbledge.xpm dcurve1.xpm dcurve2.xpm dcurve3.xpm dcurve4.xpm \
	dcircle2.xpm dcircle3.xpm dflcrcl2.xpm dflcrcl3.xpm dbox.xpm \
	dfilbox.xpm dpoly.xpm dfilpoly.xpm
$(LIB)(celev.o): celev.c track.h cselect.h elev.xpm
$(LIB)(cgroup.o): cgroup.c track.h compound.h shrtpath.h
$(LIB)(chndldto.o): chndldto.c track.h ccurve.h cstraigh.h cjoin.h compound.h hndldto.xpm
$(LIB)(chotbar.o): chotbar.c track.h compound.h hotbarl.bmp hotbarr.bmp
$(LIB)(cjoin.o): cjoin.c track.h ccurve.h cstraigh.h cjoin.h join.xpm
$(LIB)(cmisc.o): cmisc.c track.h describe.xpm
$(LIB)(cmisc2.o): cmisc2.c track.h bridge.bmp
$(LIB)(cmodify.o): cmodify.c track.h cjoin.h ccurve.h cstraigh.h extend.xpm
$(LIB)(cnote.o): cnote.c track.h note.bmp cnote.xpm

cnvdsgn.o: cnvdsgn.c common.h utility.h

$(LIB)(compound.o): compound.c track.h compound.h shrtpath.h cjoin.h
$(LIB)(cparalle.o): cparalle.c track.h ccurve.h cstraigh.h parallel.xpm
$(LIB)(cprint.o): cprint.c track.h
$(LIB)(cprofile.o): cprofile.c track.h cselect.h shrtpath.h profile.xpm
$(LIB)(cpull.o): cpull.c track.h cselect.h compound.h pull.xpm
$(LIB)(cruler.o): cruler.c track.h ruler.xpm
$(LIB)(cselect.o): cselect.c track.h ccurve.h compound.h bmendpt.bmp bma0.bmp bma45.bmp \
	bma90.bmp bma135.bmp select.xpm delete.xpm tunnel.xpm move.xpm \
	rotate.xpm flip.xpm movedesc.xpm
$(LIB)(csnap.o): csnap.c track.h cross0.bmp bigdot.bmp snapcurs.bmp snapvis.bmp
$(LIB)(csplit.o): csplit.c track.h splittrk.xpm
$(LIB)(cstraigh.o): cstraigh.c track.h cstraigh.h straight.xpm
$(LIB)(cstruct.o): cstruct.c track.h compound.h struct.xpm
$(LIB)(ctext.o): ctext.c track.h text.xpm
$(LIB)(ctodesgn.o): ctodesgn.c track.h ccurve.h cstraigh.h compound.h toreg.lin tocrv.lin \
	towye.lin to3way.lin toxing.lin tosslip.lin todslip.lin torcross.lin \
	tolcross.lin todcross.lin tostrsct.lin tocrvsct.lin tostrsct.lin \
	tostrsct.lin
$(LIB)(ctrain.o): ctrain.c track.h trackx.h ctrain.h compound.h train.xpm stop.xpm go.xpm \
	exit.xpm newcar.xpm zero.xpm
$(LIB)(cturnout.o): cturnout.c track.h ccurve.h cstraigh.h compound.h cjoin.h turnout.xpm
$(LIB)(cturntbl.o): cturntbl.c track.h cstraigh.h turntbl.xpm
$(LIB)(cundo.o): cundo.c track.h trackx.h

=== app/doc/CMakeLists.txt ===
PROJECT(doc)

IF (UNIX)
	SET( butfiles ${CMAKE_CURRENT_SOURCE_DIR}/linconf.but )
ELSE (UNIX)
	SET( butfiles ${CMAKE_CURRENT_SOURCE_DIR}/chmconf.but )
ENDIF (UNIX)	

SET( butfiles ${butfiles}
				  ${CMAKE_CURRENT_SOURCE_DIR}/intro.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/addm.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/changem.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/drawm.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/editm.but 
				  ${CMAKE_CURRENT_SOURCE_DIR}/filem.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/helpm.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/hotbar.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/macrom.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/managem.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/optionm.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/statusbar.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/view_winm.but
				  ${CMAKE_CURRENT_SOURCE_DIR}/navigation.but 
				  ${CMAKE_CURRENT_SOURCE_DIR}/appendix.but 
				  ${CMAKE_CURRENT_SOURCE_DIR}/messages.but 
				  ${CMAKE_CURRENT_SOURCE_DIR}/upgrade.but 
				  ${CMAKE_CURRENT_SOURCE_DIR}/warranty.but )

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/index.html
	DEPENDS ${butfiles}
	COMMAND ../tools/halibut/halibut ${butfiles}
	)

ADD_CUSTOM_TARGET( htmlhelp ALL
						  DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/index.html )

=== app/help/CMakeLists.txt ===
PROJECT(help)

ADD_EXECUTABLE(genmessages genmessages.c)
GET_TARGET_PROPERTY(genmessages_EXE genmessages LOCATION)

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/messages.h
	DEPENDS genmessages ${CMAKE_CURRENT_SOURCE_DIR}/messages.in
	COMMAND ${genmessages_EXE} < ${CMAKE_CURRENT_SOURCE_DIR}/messages.in 
	)

ADD_EXECUTABLE(genhelp genhelp.c)
GET_TARGET_PROPERTY(genhelp_EXE genhelp LOCATION)

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/bllnhlp.c
	DEPENDS genhelp ${CMAKE_CURRENT_SOURCE_DIR}/genhelp.in
	COMMAND ${genhelp_EXE} -bh ${CMAKE_CURRENT_SOURCE_DIR}/genhelp.in ${CMAKE_CURRENT_BINARY_DIR}/bllnhlp.c
	)

ADD_EXECUTABLE(prochelp prochelp.c readpng.c)
TARGET_LINK_LIBRARIES(prochelp png)
TARGET_LINK_LIBRARIES(prochelp z)
TARGET_LINK_LIBRARIES(prochelp m)
GET_TARGET_PROPERTY(prochelp_EXE prochelp LOCATION)

ADD_CUSTOM_COMMAND(
	OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/xtrkcad.help
	DEPENDS prochelp ${CMAKE_CURRENT_SOURCE_DIR}/xtrkcad.hlpsrc
	COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/xtrkcad.hlpsrc ${CMAKE_CURRENT_BINARY_DIR}/xtrkcad.hlpsrc
	COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/xvprintsel.hlpsrc ${CMAKE_CURRENT_BINARY_DIR}/xvprintsel.hlpsrc
	COMMAND cp ${CMAKE_CURRENT_SOURCE_DIR}/xvfontsel.hlpsrc ${CMAKE_CURRENT_BINARY_DIR}/xvfontsel.hlpsrc
	COMMAND ${prochelp_EXE} -xv -C unix xtrkcad.hlpsrc xtrkcad.help
	WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
	)

ADD_CUSTOM_TARGET(xtrkcad.help ALL
	DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/xtrkcad.help
	)

INCLUDE_DIRECTORIES(${wlib_SOURCE_DIR}/include)
ADD_LIBRARY(xtrackcad-help ${CMAKE_CURRENT_BINARY_DIR}/messages.h ${CMAKE_CURRENT_BINARY_DIR}/bllnhlp.c)

INSTALL(FILES
	xtrkcad.tip
	${CMAKE_CURRENT_BINARY_DIR}/xtrkcad.help
	DESTINATION share
	)

=== app/help/Makefile ===
RTFS = contents.rtf mswhead.rtf mswtail.rtf
HPJ = xtrkcad.hpj.first xtrkcad.hpj.last
HLPSRC = xtrkcad.hlpsrc xvfontsel.hlpsrc xvprintsel.hlpsrc
MISC = Makefile genhelp.in messages.in xtrkcad.tip
CSRCS = prochelp.c genhelp.c genmessages.c mkxpmbutt.c pageorder.c fixbmp.c readpng.c readpng.h
TOOLS = mkpngs mkpngbutt mkshg
TOOLSRCS = mkpngs mkpngbutt mkshg.c mkshgs
EXTRAS = dmpbmp dmppng

SRCS = $(RTFS) $(HPJ) $(HLPSRC) $(MISC) $(CSRCS) $(TOOLSRCS)

PNGS = \
	images.orig/bglayer.png images.orig/bhotbar.png images.orig/bitmap.png \
	images.orig/blayer.png \
	images.orig/carinv.png images.orig/caritem.png images.orig/carpart.png \
	images.orig/carproto.png images.orig/celev.png \
	images.orig/chelix.png images.orig/cparalle.png images.orig/cprofile.png \
	images.orig/ctext.png images.orig/custmgm.png \
	images.orig/dchgelev.png images.orig/demo.png images.orig/dlayer.png \
	images.orig/easeex1.png images.orig/easeex2.png images.orig/easew.png \
	images.orig/grid.png images.orig/layer.png images.orig/pricels.png \
	images.orig/print.png images.orig/prmfile.png \
	images.orig/regw.png images.orig/rescale.png images.orig/strsel.png \
	images.orig/train.png images.orig/trainbar.png images.orig/ttdiam.png \
	images.orig/turndes.png images.orig/turnsel.png \
	images.orig/updttl.png images.orig/wenum.png images.orig/wmain.png images.orig/wmap.png

all: ../bin/bllnhlp.c ../bin/messages.h ../doc/messages.but
#all: ../bin/bllnhlp.c xtrkcad.help xtrkcad.text html/xtrkcad.html ../bin/messages.h mkxpmbutt pageorder

bllnhlp.c: genhelp.in genhelp
	./genhelp -bh genhelp.in bllnhlp.out
	sed -e '/"help"/d' -e '/"cancel"/d' -e '/"close"/d' bllnhlp.out > bllnhlp.c

../bin/bllnhlp.c: bllnhlp.c
	@if [ ! -f ../bin/bllnhlp.c ] ; then \
		cp -v bllnhlp.c ../bin/bllnhlp.c ; \
	else \
	if diff bllnhlp.c ../bin/bllnhlp.c > /dev/null 2>&1 ; then \
		echo no change in bllnhlp.c; \
	else \
		cp -v bllnhlp.c ../bin/bllnhlp.c ; \
	fi ; \
	fi

messages.h messages.hlpsrc: messages.in genmessages
	./genmessages messages.in messages.but

../bin/messages.h: messages.h
	@if [ ! -f ../bin/messages.h ] ; then \
		cp -v messages.h ../bin/messages.h ; \
	else \
	if diff messages.h ../bin/messages.h > /dev/null 2>&1 ; then \
		echo no change in messages.h; \
	else \
		cp -v messages.h ../bin/messages.h ; \
	fi ; \
	fi
	
../doc/messages.but: messages.but	
	@if [ ! -f ../doc/messages.but ] ; then \
		cp -v messages.but ../doc/messages.but ; \
	else \
	if diff messages.but ../doc/messages.but > /dev/null 2>&1 ; then \
		echo no change in messages.but; \
	else \
		cp -v messages.but ../doc/messages.but ; \
	fi ; \
	fi

#popups.rtf: genhelp.in genhelp
#	./genhelp -msw genhelp.in popups.rtf

#xtrkcad.info: genhelp.in genhelp
#	./genhelp -xv genhelp.in xtrkcad.info

#xtrkcad.help: xtrkcad.hlpsrc messages.hlpsrc prochelp messages.hlpsrc
#	./prochelp -xv -C unix xtrkcad.hlpsrc xtrkcad.help

#xtchelp.d/xtrkcad.hpj: genhelp.in genhelp xtrkcad.hpj.first xtrkcad.hpj.last
#	@if [ ! -d xtchelp.d ] ; then mkdir xtchelp.d ; fi
#	./genhelp -hpj genhelp.in popups.ali
#	cat xtrkcad.hpj.first popups.ali xtrkcad.hpj.last > xtchelp.d/xtrkcad.hpj

#xtchelp: xtchelp.d/xtrkcad.hpj mkshgs mkshg
#	./mkshgs
#	@make xtchelp.d/xtrkcad.rtf

#checkshgs:
#	@make bmps
#	@for BMP in bmps.d/*.bmp ; do \
#		SHG=`echo $$BMP|sed -e 's/\.bmp/.shg/' -e 's/bmps.d/winhelp.d/'`; \
#		if [ ! -f $$SHG -o $$BMP -nt $$SHG ] ; then \
#			echo update $$SHG ; \
#		fi \
#	done
	
#xtchelp.d/xtrkcad.rtf: xtrkcad.hlpsrc messages.hlpsrc prochelp popups.rtf mswhead.rtf mswtail.rtf
#	@if [ ! -d xtchelp.d ] ; then mkdir xtchelp.d ; fi
#	( cat mswhead.rtf ; \
#	  ./prochelp -mswhelp -C msw xtrkcad.hlpsrc - ; \
#	  cat popups.rtf mswtail.rtf ) | \
#	  sed 's/{\\b XTrkCad}/{\\b\\i XTrkCad}/g' > xtchelp.d/xtrkcad.rtf

#bmps:
#	@if [ ! -d bmps.d ] ; then mkdir bmps.d ; fi
#	@for GIF in gifs.d/*.gif images.orig/*.gif ; do \
#		BMP=`echo $$GIF|sed -e 's/\.gif/.bmp/' -e 's/gifs.d/bmps.d/' -e 's/images.orig/bmps.d/'`; \
#		if [ ! -f $$BMP -o $$GIF -nt $$BMP  ] ; then \
#			echo updating $$BMP ; \
#			convert +compress $$GIF BMP:$$BMP ; \
#		fi \
#	done

#pngs: mkpngbutt mkxpmbutt
#	@if [ ! -d png.d ] ; then mkdir png.d ; fi
#	./mkpngs

#xtcword: #pngs
#	@make xtcword.d/xtcword.rtf

#xtcword.d/xtcword.rtf: xtrkcad.hlpsrc messages.hlpsrc prochelp mswhead.rtf mswtail.rtf # png.d/*.png images.orig/*.png
#	@if [ ! -d xtcword.d ] ; then mkdir xtcword.d ; fi
#	@( sed 's/fs20/fs22/g' mswhead.rtf ; \
#	  ./prochelp -mswword -C msw -toc -d png.d -d images.orig -ml 0.50 -mr 0.50 -mg 0.25 -mb 0.25 -mt 0.25 xtrkcad.hlpsrc - ; \
#	  cat mswtail.rtf ) | \
#	  sed 's/{\\b XTrkCad}/{\\b\\i XTrkCad}/g' > xtcword.d/xtcword.rtf

#test.rtf:
#	( sed 's/fs20/fs22/g' mswhead.rtf ; \
#	  ./prochelp -mswword -C msw -toc -d png.d -d images.orig -ml 0.50 -mr 0.50 -mg 0.25 -mb 0.25 -mt 0.25 test.hlpsrc - ; \
#	  cat mswtail.rtf ) | \
#	  sed 's/{\\b XTrkCad}/{\\b\\i XTrkCad}/g' > xtcword.d/test.rtf

#xtrkcad.text: xtrkcad.hlpsrc messages.hlpsrc prochelp
#	./prochelp -text -C unix xtrkcad.hlpsrc xtrkcad.text

#html/xtrkcad.html: xtrkcad.hlpsrc messages.hlpsrc prochelp
#	@rm -rf html
#	mkdir html
#	@cd html ; ln -s ../png.d/*.png ../images.orig/*.png ./
#	cd html ; ../prochelp -html -C unix -d .. xtrkcad.hlpsrc xtrkcad

#prochelp: prochelp.c readpng.c
#	cc -g -o prochelp prochelp.c readpng.c -lpng -lz -lm

#mkxmpbutt: mkxmpbutt.c
#	cc -g -o mkxmpbutt mkxmpbutt.c

#pageorder: pageorder.c
#	cc -g -o pageorder pageorder.c

genhelp: genhelp.c
	cc -g -o genhelp genhelp.c

genmessages: genmessages.c
	cc -g -o genmessages genmessages.c

#dmpbmp: dmpbmp.o
#	cc -o dmpbmp dmpbmp.o
#dmpbmp.o: dmpbmp.c
#	cc -g -c dmpbmp.c

#mkshg: mkshg.o readpng.o
#	cc -o mkshg mkshg.o readpng.o -lpng -lz -lm
#mkshg.o: mkshg.c readpng.h
#	cc -g -c mkshg.c
#dmppng: dmppng.o readpng.o
#	cc -o dmppng dmppng.o readpng.o -lpng -lz -lm
#dmppng.o: dmppng.c
#	cc -g -c dmppng.c
#readpng.o: readpng.c png.h readpng.h
#	cc -g -c readpng.c

src:
	@echo $(SRCS) $(PNGS)

rcssrc:
	@echo $(SRCS)

tar:
	tar cvf track.tar $(SRCS)

tag:
	if [ "$(TAG)"x = "x" ] ; then echo define TAG ; else rcs -N$(TAG):HEAD $(SRCS) ; fi

fetch:
	if [ "$(TAG)"x != "x" ] ; then TAG=-r$(TAG) ; fi ;\
	co $$TAG  $(SRCS)

clean:
	rm -f bllnhlp.c bllnhlp.out genhelp genmessages messages.h messages.hlpsrc mkxpmbutt pageorder 
	rm -f prochelp xtrkcad.help xtrkcad.text
	rm -fr html  png.d



bllnhlp.o: bllnhlp.c wlib.h
prochelp.o: prochelp.c readpng.h

=== app/lib/CMakeLists.txt ===
PROJECT(lib)

ADD_SUBDIRECTORY(demos)
ADD_SUBDIRECTORY(examples)
ADD_SUBDIRECTORY(params)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/xtrkcad.ini ${CMAKE_CURRENT_BINARY_DIR}/xtrkcad.ini)

INSTALL(FILES 
	COPYING
	aareadme.txt
	xtrkcad.bug
	xtrkcad.enh
	xtrkcad.fix
	${CMAKE_CURRENT_BINARY_DIR}/xtrkcad.ini
	xtrkcad.spec.head
	xtrkcad.xtq
	DESTINATION share
	)

=== app/lib/Makefile ===
#
# $Header: /cvsroot/xtrkcad-fork/xtrkcad/app/lib/Makefile,v 1.1 2005/12/07 15:47:39 rc-flyer Exp $
#

CC = gcc

VER = d
COPTS = -Wall
PACKAGEDIR = ./package
VER=0.1

all: debug

GENFILES = xtrkcad.upd
#GENFILES = xtrkcad.ini xtrkcad.upd
#MISC = Makefile aareadme.txt xtrkcad.mst0 xtrkcad.mst1 mklyt xtrkcad.lst
MISC = Makefile aareadme.txt xtrkcad.spec.head COPYING
XTQ = \
	xtrkcad.xtq


HELPFILES = xtrkcad.bug xtrkcad.fix xtrkcad.enh

SRCS = $(MISC) $(XTQ) $(HELPFILES)

update: debug product

debug: $(GENFILES)
	@echo nothing to do

product: $(GENFILES)
	@echo nothing to do

xtrkcad.mst: xtrkcad.mst0 xtrkcad.mst1
	cat xtrkcad.mst0 > xtrkcad.mst
	N=1; \
	for f in `make --no-print-director -f params/Makefile xtps` ; do \
		echo '    CreateIniKeyValue MakePath( GetWindowsDir(), "XTRKCAD.INI" ), "Parameter File Update", "File'$$N'", MakePath( SUBDIR$$, "'$$f'" ), cmoOverwrite
' >> xtrkcad.mst; \
		N=`expr $$N + 1`; \
	done; \
	cat xtrkcad.mst1 >> xtrkcad.mst

xtrkcad.lyt: mklyt
	@./mklyt xtrkcad

xtrkcad.upd:
	( date "+%Y%m%d" ; \
	for f in `make --no-print-director -f params/Makefile xtps` ; do \
	echo $$f ; done ) > xtrkcad.upd

checked:
	@echo nothing to do

tar:
	tar cvf xtclib.tar $(SRCS)

tag:
	if [ "$(TAG)"x = "x" ] ; then echo define TAG ; else rcs -N$(TAG):HEAD $(SRCS) ; fi

fetch:
	if [ "$(TAG)"x != "x" ] ; then TAG=-r$(TAG) ; fi ;\
	co $$TAG  $(SRCS)

src:
	@echo $(SRCS)

rcssrc:
	@echo $(SRCS)

xtrkcad.ini: Makefile params/Makefile
	echo '[file]' 			> xtrkcad.ini
	echo 'directory=$$i\EXAMPLES'	>> xtrkcad.ini
	echo 'paramdir=$$i\PARAMS'	>> xtrkcad.ini
	echo ''				>> xtrkcad.ini
	echo '[draw]'			>> xtrkcad.ini
	echo 'roomsizeX=96.0'		>> xtrkcad.ini
	echo 'roomsizeY=48.0'		>> xtrkcad.ini
	echo ''				>> xtrkcad.ini
	echo '[Parameter File Update]'	>> xtrkcad.ini
	N=1; \
	for f in `make --no-print-director -f params/Makefile xtps` ; do \
		echo 'File'$$N'=$$i\PARAMS\'$$f >> xtrkcad.ini; \
		N=`expr $$N + 1`; \
	done


rpm:
	#if [ ! -d ../usr ] ; then mkdir -p ../install/usr/local/lib ; ln -s ../../../../xtrkcad ../install/usr/local/lib/xtrkcad ; fi
	D=`pwd`; D=`dirname $$D`; D=`basename $$D`; \
	V=`echo $$D | sed -e 's/^r//' -e 's/_/./g'`; \
	sed -e "s/RLSEDIR/$$D/g" -e "s/RLSEVER/$$V/g"  xtrkcad.spec.head > xtrkcad.spec
	cd .. ; find xtrkcad -type f -print | sed 's/^/\/usr\/local\/lib\//' | sed '/html/s/^/%doc /' | sed '/xtrkcad.help/s/^/%doc /' >> lib/xtrkcad.spec

	if [ ! -d ../usr ] ; then mkdir -p ../install/usr/local/lib ; mv  ../xtrkcad ../install/usr/local/lib/xtrkcad ; fi
	cd ..; rpm -bb lib/xtrkcad.spec

clean:
	cd params; make clean
	rm -f xtrkcad.help xtrkcad.spec xtrkcad.upd

=== app/tools/CMakeLists.txt ===
add_subdirectory(halibut)

add_executable(addcrlf addcrlf.c)

add_executable(bin2c bin2c.c)

=== app/tools/Makefile ===
# CMAKE generated file: DO NOT EDIT!
# Generated by "Unix Makefiles" Generator, CMake Version 2.4

# Default target executed when no arguments are given to make.
default_target: all

#=============================================================================
# Special targets provided by cmake.

# Disable implicit rules so canoncical targets will work.
.SUFFIXES:

.SUFFIXES: .hpux_make_needs_suffix_list

# Suppress display of executed commands.
$(VERBOSE).SILENT:

# A target that is always out of date.
cmake_force:

#=============================================================================
# Set environment variables for the build.

# The shell in which to execute make rules.
SHELL = /bin/sh

# The CMake executable.
CMAKE_COMMAND = /usr/local/bin/cmake

# The command to remove a file.
RM = /usr/local/bin/cmake -E remove -f

# The program to use to edit the cache.
CMAKE_EDIT_COMMAND = /usr/local/bin/ccmake

# The top-level source directory on which CMake was run.
CMAKE_SOURCE_DIR = /home/martin/xtc/xtrkcad/app/tools

# The top-level build directory on which CMake was run.
CMAKE_BINARY_DIR = /home/martin/xtc/xtrkcad/app/tools

# Include the progress variables for this target.
include CMakeFiles/progress.make

#=============================================================================
# Targets provided globally by CMake.

# Special rule for the target edit_cache
edit_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake cache editor..."
	/usr/local/bin/ccmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)

# Special rule for the target edit_cache
edit_cache/fast: edit_cache

# Special rule for the target rebuild_cache
rebuild_cache:
	@$(CMAKE_COMMAND) -E cmake_echo_color --switch=$(COLOR) --cyan "Running CMake to regenerate build system..."
	/usr/local/bin/cmake -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR)

# Special rule for the target rebuild_cache
rebuild_cache/fast: rebuild_cache

# The main all target
all: cmake_check_build_system
	$(CMAKE_COMMAND) -E cmake_progress_start /home/martin/xtc/xtrkcad/app/tools/CMakeFiles $(CMAKE_ALL_PROGRESS)
	$(MAKE) -f CMakeFiles/Makefile2 all
	$(CMAKE_COMMAND) -E cmake_progress_start /home/martin/xtc/xtrkcad/app/tools/CMakeFiles 0

# The main clean target
clean:
	$(MAKE) -f CMakeFiles/Makefile2 clean

# The main clean target
clean/fast: clean

# Prepare targets for installation.
preinstall: all
	$(MAKE) -f CMakeFiles/Makefile2 preinstall

# Prepare targets for installation.
preinstall/fast:
	$(MAKE) -f CMakeFiles/Makefile2 preinstall

# clear depends
depend:
	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 1

#=============================================================================
# Target rules for targets named addcrlf

# Build rule for target.
addcrlf: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 addcrlf

# fast build rule for target.
addcrlf/fast:
	$(MAKE) -f CMakeFiles/addcrlf.dir/build.make CMakeFiles/addcrlf.dir/build

#=============================================================================
# Target rules for targets named bin2c

# Build rule for target.
bin2c: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 bin2c

# fast build rule for target.
bin2c/fast:
	$(MAKE) -f CMakeFiles/bin2c.dir/build.make CMakeFiles/bin2c.dir/build

#=============================================================================
# Target rules for targets named halibut

# Build rule for target.
halibut: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 halibut

# fast build rule for target.
halibut/fast:
	$(MAKE) -f halibut/CMakeFiles/halibut.dir/build.make halibut/CMakeFiles/halibut.dir/build

#=============================================================================
# Target rules for targets named charset

# Build rule for target.
charset: cmake_check_build_system
	$(MAKE) -f CMakeFiles/Makefile2 charset

# fast build rule for target.
charset/fast:
	$(MAKE) -f halibut/charset/CMakeFiles/charset.dir/build.make halibut/charset/CMakeFiles/charset.dir/build

# target to build an object file
addcrlf.o:
	$(MAKE) -f CMakeFiles/addcrlf.dir/build.make CMakeFiles/addcrlf.dir/addcrlf.o

# target to preprocess a source file
addcrlf.i:
	$(MAKE) -f CMakeFiles/addcrlf.dir/build.make CMakeFiles/addcrlf.dir/addcrlf.i

# target to generate assembly for a file
addcrlf.s:
	$(MAKE) -f CMakeFiles/addcrlf.dir/build.make CMakeFiles/addcrlf.dir/addcrlf.s

# target to build an object file
bin2c.o:
	$(MAKE) -f CMakeFiles/bin2c.dir/build.make CMakeFiles/bin2c.dir/bin2c.o

# target to preprocess a source file
bin2c.i:
	$(MAKE) -f CMakeFiles/bin2c.dir/build.make CMakeFiles/bin2c.dir/bin2c.i

# target to generate assembly for a file
bin2c.s:
	$(MAKE) -f CMakeFiles/bin2c.dir/build.make CMakeFiles/bin2c.dir/bin2c.s

# Help Target
help::
	@echo "The following are some of the valid targets for this Makefile:"
	@echo "... all (the default if no target is provided)"
	@echo "... clean"
	@echo "... depend"
	@echo "... addcrlf"
	@echo "... bin2c"
	@echo "... edit_cache"
	@echo "... rebuild_cache"
	@echo "... addcrlf.o"
	@echo "... addcrlf.i"
	@echo "... addcrlf.s"
	@echo "... bin2c.o"
	@echo "... bin2c.i"
	@echo "... bin2c.s"
	@echo "... halibut"
	@echo "... addcrlf.o"
	@echo "... addcrlf.i"
	@echo "... addcrlf.s"
	@echo "... bin2c.o"
	@echo "... bin2c.i"
	@echo "... bin2c.s"
	@echo "... charset"
	@echo "... addcrlf.o"
	@echo "... addcrlf.i"
	@echo "... addcrlf.s"
	@echo "... bin2c.o"
	@echo "... bin2c.i"
	@echo "... bin2c.s"



#=============================================================================
# Special targets to cleanup operation of make.

# Special rule to run CMake to check the build system integrity.
# No rule that depends on this can have commands that come from listfiles
# because they might be regenerated.
cmake_check_build_system:
	$(CMAKE_COMMAND) -H$(CMAKE_SOURCE_DIR) -B$(CMAKE_BINARY_DIR) --check-build-system CMakeFiles/Makefile.cmake 0

=== app/wlib/CMakeLists.txt ===
PROJECT(wlib)

INCLUDE_DIRECTORIES("${wlib_SOURCE_DIR}/include")

IF(WIN32)
	ADD_SUBDIRECTORY(mswlib)
ELSE(WIN32)
	ADD_SUBDIRECTORY(gtklib)
ENDIF(WIN32)

=== debian/changelog ===
xtrkcad (1:4.0.2-2ubuntu1) natty; urgency=low

  * Change build-depends from libwebkit-dev to libwebkitgtk-dev as a
    part of webkit transition.
    - update debian/control

 -- Bhavani Shankar <bhavi@ubuntu.com>  Wed, 19 Jan 2011 15:24:54 +0530

xtrkcad (1:4.0.2-2) unstable; urgency=low

  * new maintainer, closes: #383968
  * switched help system to libwebkit, closes: #549039

 -- Daniel E. Markle <dmarkle@ashtech.net>  Fri, 25 Jun 2010 07:59:01 -0400

xtrkcad (1:4.0.2-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * chmod +x sbcsgen.pl script used in building (Closes: 482257)
    - required by newer versions of cmake

 -- Mike O'Connor <stew@debian.org>  Tue, 03 Jun 2008 21:54:51 -0400

xtrkcad (1:4.0.2-1) unstable; urgency=low

  * new uptream version, closes: #458077
  * fix path to docs in man page, closes: #458319

 -- Bdale Garbee <bdale@gag.com>  Tue, 15 Apr 2008 22:50:44 -0600

xtrkcad (1:4.0.1-1) unstable; urgency=low

  * new upstream version
  * building twice in a row appears to work now, closes: #424098
  * don't strip in bin/Makefile, closes: #438353

 -- Bdale Garbee <bdale@gag.com>  Wed, 05 Sep 2007 13:43:47 +0100

xtrkcad (20061215-1) unstable; urgency=low

  * freshen from upstream CVS (just one minor variable initialization patch)

 -- Bdale Garbee <bdale@gag.com>  Fri, 15 Dec 2006 09:54:11 -0700

xtrkcad (20060529-2) unstable; urgency=low

  * add build dependency on imagemagick, closes: #374639

 -- Bdale Garbee <bdale@gag.com>  Tue, 20 Jun 2006 11:31:30 -0600

xtrkcad (20060529-1) unstable; urgency=low

  * new upstream version
  * move from xtrkcad (dormant) to xtrkcad-fork on advice from Alistair Baty
  * update control file to reflect this is no longer feature-reduced

 -- Bdale Garbee <bdale@gag.com>  Mon, 29 May 2006 22:45:15 -0600

xtrkcad (20060415-1) unstable; urgency=low

  * xtrkcad is now GPL'ed, so it can move to main!  closes: #318369
  * building a CVS snapshot from sourceforge
  * fix priority to match override file
  * should build anywhere, so change from i386 to any

 -- Bdale Garbee <bdale@gag.com>  Sat, 15 Apr 2006 11:22:33 -0600

xtrkcad (3.1.4-1) unstable; urgency=low

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Sat, 15 Nov 2003 15:23:21 -0700

xtrkcad (3.1.2.3-1) unstable; urgency=low

  * new upstream version, actually 3.1.2-3 in Sillub's notation
  * freshen packaging to current standards

 -- Bdale Garbee <bdale@gag.com>  Wed,  6 Nov 2002 17:15:48 -0700

xtrkcad (2.2.0-2) unstable; urgency=low

  * update to current standards, FHS, clean up lintian report

 -- Bdale Garbee <bdale@gag.com>  Fri,  7 Jan 2000 21:29:01 -0700

xtrkcad (2.2.0-1) unstable; urgency=low

  * new upstream version

 -- Bdale Garbee <bdale@gag.com>  Wed, 26 May 1999 13:27:32 -0600

xtrkcad (2.0.4-1) unstable; urgency=low

  * new upstream version, closes 20040
  * minor cleanups to files in debian directory to close all Lintian errors,
    some warnings remain since this is a libc5 binary-only package, etc...

 -- Bdale Garbee <bdale@gag.com>  Sun,  6 Sep 1998 12:05:54 -0600

xtrkcad (1.2.1-4) unstable; urgency=low

  * fix a bunch of packaging funnies found by lintian
  * move from debstd to debhelper

 -- Bdale Garbee <bdale@gag.com>  Sun, 15 Feb 1998 11:45:26 -0700

xtrkcad (1.2.1-3) unstable; urgency=low

  * add new param files from Sillub web page.  These add a P4 scale,
    update the Walthers HP structure lib, and add libs for Arnold N
    scale turnouts, Peco HO scale turnouts, and UK P4 fine scale 
    turnouts.  There's also a new example layout.  Closes bug 16388.
  * don't gzip example layouts, since they are then invisible to the file
    menu, which is really confusing.
  * add support for update-menus.

 -- Bdale Garbee <bdale@gag.com>  Sat,  3 Jan 1998 01:14:23 -0700

xtrkcad (1.2.1-2) unstable; urgency=low

  * moved html stuff out of /usr/lib and into /usr/doc
  * repackaged to get dependency information right for hamm

 -- Bdale Garbee <bdale@gag.com>  Sat, 25 Oct 1997 11:39:58 -0600

xtrkcad (1.2.1-1) unstable; urgency=low

  * new upstream version, converted with alien and merged with Debian 
    diffs from 1.2.0
  * moved from contrib to non-free since no source is available
  * included example layouts from the Sillub web pages

 -- Bdale Garbee <bdale@gag.com>  Sun,  7 Sep 1997 18:21:34 -0600

xtrkcad (1.2.0-2) unstable; urgency=low
 
  * Moving from contrib to non-free to meet new policy on such.

 -- Bdale Garbee <bdale@gag.com>  Wed, 6 Aug 1997 14:04:12 -0600

xtrkcad (1.2.0-1) unstable; urgency=low

  * Converted from distributed .tar.gz format to a Debian package

 -- Bdale Garbee <bdale@gag.com>  Mon, 31 Mar 1997 17:28:01 -0700

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: xtrkcad
Section: editors
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel E. Markle <dmarkle@ashtech.net>
Build-Depends: debhelper (>= 5), libglib2.0-dev, libgtk2.0-dev, libx11-dev, netpbm, imagemagick, libwebkitgtk-dev, cmake
Standards-Version: 3.8.4

Package: xtrkcad
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Model Train Track CAD Program
 This program allows you to design model train layouts.  It is fundamentally
 a drawing (CAD) program, but tailored to some of the specific issues in the
 model train world.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build: build-stamp
build-stamp:
	dh_testdir

	chmod +x app/tools/halibut/charset/sbcsgen.pl

	(cd app ; $(MAKE) )

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	(cd app ; $(MAKE) clean )
	rm -f build-stamp
	dh_clean

binary-indep: build

binary-arch: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
	cp -r app/lib/* debian/xtrkcad/usr/lib/xtrkcad/
	chmod -x debian/xtrkcad/usr/lib/xtrkcad/logo.bmp
	cp app/doc/*.html debian/xtrkcad/usr/share/xtrkcad/html/
	cp -r app/doc/png.d debian/xtrkcad/usr/share/xtrkcad/html/
	ln -s ../../share/xtrkcad/html debian/xtrkcad/usr/lib/xtrkcad/html
	cp app/bin/xtrkcad app/help/xtrkcad.tip \
		debian/xtrkcad/usr/lib/xtrkcad/
	/usr/bin/install -c -m 755 debian/wrapper.sh \
		debian/xtrkcad/usr/bin/xtrkcad
	rm -f debian/xtrkcad/usr/lib/xtrkcad/COPYING
	dh_installdocs 
	dh_installmenu
	dh_installcron
	dh_installman debian/xtrkcad.1
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

source diff:                                                                  
	@echo >&2 'source and diff are obsolete - use dpkg-source -b'; false

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary

## xtrkcad 4.1.99+4.2.0

=== debian/changelog ===
xtrkcad (1:4.1.99+4.2.0-beta1) experimental; urgency=low

  * new upstream version
  * packaging updates and fixes

 -- Daniel E. Markle <dmarkle@ashtech.net>  Fri, 25 Mar 2011 18:55:43 -0400

=== debian/control ===
Source: xtrkcad
Section: editors
Priority: extra
Maintainer: Daniel E. Markle <dmarkle@ashtech.net>
Build-Depends: debhelper (>= 7.0.50~), libglib2.0-dev, libgtk2.0-dev, libx11-dev, netpbm, imagemagick, libwebkit-dev, libcairo2-dev, cmake
Standards-Version: 3.9.1
Homepage: http://xtrkcad.org/
#Vcs-Git: git://git.debian.org/collab-maint/xtrkcad.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/xtrkcad.git;a=summary

Package: xtrkcad
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Model Train Track CAD Program
 This program allows you to design model train layouts.  It is fundamentally
 a drawing (CAD) program, but tailored to some of the specific issues in the
 model train world.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

build:
	dh_testdir
	mkdir -p build
	(cd build ; cmake -D=CMAKE_BUILD_TYPE=Release \
	-D CMAKE_INSTALL_PREFIX=/usr/ \
	-D XTRKCAD_USE_GETTEXT=ON \
	-D XTRKCAD_USE_GTK=ON \
	-D XTRKCAD_USE_GTK_CAIRO=ON \
	-D XTRKCAD_USE_LAYOUTCONTROL=ON ../)
	(cd build ; make)

clean:
	dh_testdir
	rm -rf build
	dh_clean

binary-indep: build

binary-arch: build
	dh_testdir
	dh_testroot
	dh_installdirs
	dh_installdocs
	dh_auto_install -Dbuild
	rm -f debian/xtrkcad/usr/share/xtrkcad/COPYING
	dh_install
	dh_installmenu
	dh_installman debian/xtrkcad.1
	dh_installchangelogs
	dh_strip
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary
